import { Component, OnInit, ViewChild, TemplateRef } from '@angular/core';
import { FormBuilder, FormGroup } from '@angular/forms';
import { extractFormGroupData, buildNestedFormGroup } from './dynaform/libs';

import { formMetaDataObj } from './_mock/testfields';

@Component({
	selector: 'app-root',
	templateUrl: './app.component.html',
	styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit {

	form: FormGroup;

	formMetaDataObj = formMetaDataObj;

	@ViewChild('testTemplate', { read: TemplateRef })
	private tref: TemplateRef<any>;

	constructor(
		protected fb: FormBuilder
	) {
	}

	ngOnInit() {
		this.form = this.fb.group({
			dynaformtest: this.fb.group(extractFormGroupData(formMetaDataObj))
		});
		console.log('TESTING');
		console.log(buildNestedFormGroup(formMetaDataObj));
	}
}

