import { Component } from '@angular/core';
import { CustomInputComponent } from './../../_abstract/custom-input.component';

@Component({
	selector: 'app-checkbutton',
	templateUrl: './checkbutton.component.html',
	styleUrls: ['./checkbutton.component.scss'],
})
export class CheckbuttonComponent extends CustomInputComponent {

	exposeMetaInTemplate: string[] = ['label', 'value', 'isDisabled'];

	value: string | boolean = true;
	isDisabled = false;
	isChecked: boolean;
	currentValue: string | boolean;

	private toggleChecked(e): void {
		e.target.blur();
		e.preventDefault();
		if (this.isDisabled) { return; }
		this.isChecked = !this.isChecked;
		this.currentValue = this.isChecked ? this.value : false;
		this.propagateChange(this.currentValue);
	}

	public writeValue(value: any): void {
		this.isChecked = value && value !== 0 && value !== 'false' ? value : false;
		this.currentValue = this.isChecked ? value : false;
	}

}
