import { FormBuilder, FormGroup } from '@angular/forms';
import { reduce } from 'lodash/fp';

// Utility function for extracting a FormGroup from a form metadata object - currently non-nested only
const reducerIteree = (res, field) => Object.assign(res, { [field.name]: field.value || '' });
const _extractFormGroupData = reduce(reducerIteree, {});
const extractFormGroupData = nonNestedFormMetaData => _extractFormGroupData(nonNestedFormMetaData);

// Build Form Group
const fb = new FormBuilder();
const buildNonNestedFormGroup = nonNestedFormMetaData => fb.group(extractFormGroupData(nonNestedFormMetaData));
const nestedReducerIteree = (acc, fieldOrGroup) => {
	console.log(Array.isArray(fieldOrGroup.meta));
	return Array.isArray(fieldOrGroup.meta) ?
		buildNestedFormGroup(fieldOrGroup.meta) :
		buildNonNestedFormGroup(fieldOrGroup);
};
const _buildNestedFormGroup = reduce(nestedReducerIteree, {});
const buildNestedFormGroup = nestedFormMetaData => _buildNestedFormGroup(nestedFormMetaData);

// ---------------------------------------------------------------------------------------------------------------------
// Exports

export { extractFormGroupData, buildNestedFormGroup };
